-- UFO Utilites to make your special stage harder or easier.

-- ufohealthmultiplier - Mutlipiles the UFO's health.

-- ufolowestspeed - Forces the UFO to be at this speed

-- ufospeedfair - Makes the UFO speed more fair with lowest speed by slowing down when ahead.

-- ufoeasywaterskiing - Makes it much easier to hit the UFO while on water

addHook("MobjThinker", function(ufo)
	if leveltime == 1
		if mapheaderinfo[gamemap].ufohealthmultiplier
			local multi = mapheaderinfo[gamemap].ufohealthmultiplier
			ufo.health = $*multi
		end
	end
	
	if mapheaderinfo[gamemap].ufolowestspeed
		local speed = tonumber(mapheaderinfo[gamemap].ufolowestspeed*FRACUNIT)
		local emeraldspeed = tonumber(mapheaderinfo[gamemap].ufolowestspeed*FRACUNIT)+10*FRACUNIT
		if mapheaderinfo[gamemap].ufospeedfair -- Allow the ufo to slow down when too far ahead.
			local pitydist = (1250)
			local playerfinishdist = 0
			local ufodisttofinish = ufo.extravalue2
			
			for p in players.iterate
				playerfinishdist = p.distancetofinish
			end
			
			local ufodistance = playerfinishdist-ufodisttofinish
			
			if ufodistance < pitydist
				if ufo.watertop < speed
					if ufo.health >= 1
						if playerfinishdist < ufodisttofinish
							ufo.watertop = $+(FRACUNIT >> 1)*8 -- accelerate
						else
						ufo.watertop = $+(FRACUNIT >> 1)*4 -- accelerate
						end
						--print(ufo.watertop)
					else
						ufo.watertop = $+(FRACUNIT)*2 -- accelerate
						--print(ufo.watertop)
					end
				end
			else
				--print(ufodistance)
			end
		else
			if ufo.watertop < speed
				ufo.watertop = speed -- force speed
				--print(speed)
			end
		end
	end
end, MT_SPECIAL_UFO)

addHook("MobjDamage", function(ufo, inf)
	if mapheaderinfo[gamemap].ufoeasywaterskiing
		if inf.player
			local rover = inf.floorrover
			if P_MobjFlip(inf)
				rover = inf.ceilingrover
			else
				rover = inf.floorrover
			end
			
			if (rover and (rover.fofflags & FOF_SWIMMABLE))
				--print(1001001)
				P_Thrust(inf, inf.angle, 20*FRACUNIT)
				inf.player.numsneakers = 2
				inf.player.sneakertimer = TICRATE
			end
		end
	end
end, MT_SPECIAL_UFO)

addHook("PlayerThink", function(player)
	if player and player.valid
		if mapheaderinfo[gamemap].rocketsneakerrefill
			if player.rocketsneakertimer	
				player.rocketsneakertimer = min($+4, 25*TICRATE)
			end
		end
	end
end)